﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class AdvanceDecl_Line
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
        End Sub

        Protected Overrides Sub CalcBar()
            Me.Plot1.Set(0, Me.m_advancedeclinediff1.Item(0))
        End Sub

        Protected Overrides Sub Create()
            Me.m_advancedeclinediff1 = New AdvanceDeclineDiff(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("A/DLine", EPlotShapes.Line, Color.Cyan, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_advissues = MyBase.Bars.Close
            Me.m_decissues = MyBase.BarsOfData(2).Close
            Me.m_advancedeclinediff1.advissues = Me.advissues
            Me.m_advancedeclinediff1.decissues = Me.decissues
        End Sub


        ' Properties
        Private ReadOnly Property advissues As ISeries(Of Double)
            Get
                Return Me.m_advissues
            End Get
        End Property

        Private ReadOnly Property decissues As ISeries(Of Double)
            Get
                Return Me.m_decissues
            End Get
        End Property


        ' Fields
        Private m_advancedeclinediff1 As AdvanceDeclineDiff
        Private m_advissues As ISeries(Of Double)
        Private m_decissues As ISeries(Of Double)
        Private Plot1 As IPlotObject
    End Class
End Namespace

