﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    <SameAsSymbol(True)> _
    Public Class TrendLines_Automatic
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_swhistrength = 4
            Me.m_swlostrength = 4
            Me.m_barspast = 10
            Me.m_history = "Yes"
            Me.m_dntlcolor = Color.Red
            Me.m_uptlcolor = Color.Cyan
            Me.m_alerttype = "IntraBar"
        End Sub

        Protected Overrides Sub CalcBar()
            If (MyBase.Bars.CurrentBar = 1) Then
                Me.m_historytf.Value = ((Me.history.ToUpper = "YES") OrElse (Me.history.ToUpper = "Y"))
            End If
            Me.m_barnum = Me.m_barnumber1.Item(0)
            If (Me.m_swinghighbar1.Item(0) = Me.swhistrength) Then
                Me.m_value1 = 9
                Do While (Me.m_value1 >= 0)
                    Me.m_swhitime.Item(0)((Me.m_value1 + 1)) = Me.m_swhitime.Item(0)(Me.m_value1)
                    Me.m_swhival.Item(0)((Me.m_value1 + 1)) = Me.m_swhival.Item(0)(Me.m_value1)
                    Me.m_value1 -= 1
                Loop
                Me.m_swhitime.Item(0)(0) = MyBase.Bars.Time.Item(Me.swhistrength)
                Me.m_swhival.Item(0)(0) = MyBase.Bars.High.Item(Me.swhistrength)
                Me.m_value2 = 1
                Do While (Me.m_value2 <= 10)
                    If (Me.m_swhival.Item(0)(Me.m_value2) > Me.m_swhival.Item(0)(0)) Then
                        Me.m_index.Value = Me.m_value2
                        Me.m_value2 = 11
                    End If
                    Me.m_value2 += 1
                Loop
                If (Me.m_value2 = 12) Then
                    If ((Not Me.m_dntlref.Item(0) Is Nothing) AndAlso Me.m_dntlref.Item(0).Exist) Then
                        If Not If(Not Me.m_historytf.Value, True, Me.m_dntlbreak.Value) Then
                            Me.m_dntlref.Value.End = New ChartPoint(MyBase.Bars.Time.Item(0), Me.m_dntlref.Value.PriceValue(MyBase.Bars.Time.Item(0)))
                            Me.m_dntlref.Value.ExtRight = False
                        ElseIf Not Me.m_historytf.Value Then
                            Me.m_dntlref.Value.Delete()
                        End If
                    End If
                    Me.m_dntlref.Value = MyBase.DrwTrendLine.Create(New ChartPoint(Me.m_swhitime.Item(0)(Me.m_index.Value), Me.m_swhival.Item(0)(Me.m_index.Value)), New ChartPoint(Me.m_swhitime.Item(0)(0), Me.m_swhival.Item(0)(0)))
                    If Me.m_dntlbreak.Value Then
                        Me.m_dntlbreak.Value = False
                    End If
                    Me.m_dntlendbar.Value = (Me.m_barnum - Me.swhistrength)
                    Me.m_dntlref.Value.ExtLeft = False
                    Me.m_dntlref.Value.ExtRight = True
                    Me.m_dntlref.Value.Color = Me.m_dntlcolornum
                    If (Me.m_alerttypecaps = "ONCLOSE") Then
                        Me.m_dntlref.Value.Alert = EAlertType.BreakoutOnClose
                    ElseIf (Me.m_alerttypecaps = "INTRABAR") Then
                        Me.m_dntlref.Value.Alert = EAlertType.BreakoutIntrabar
                    Else
                        Me.m_dntlref.Value.Alert = EAlertType.Disabled
                    End If
                End If
            End If
            If (Me.m_swinglowbar1.Item(0) = Me.swlostrength) Then
                Me.m_value1 = 9
                Do While (Me.m_value1 >= 0)
                    Me.m_swlotime.Item(0)((Me.m_value1 + 1)) = Me.m_swlotime.Item(0)(Me.m_value1)
                    Me.m_swloval.Item(0)((Me.m_value1 + 1)) = Me.m_swloval.Item(0)(Me.m_value1)
                    Me.m_value1 -= 1
                Loop
                Me.m_swlotime.Item(0)(0) = MyBase.Bars.Time.Item(Me.swlostrength)
                Me.m_swloval.Item(0)(0) = MyBase.Bars.Low.Item(Me.swlostrength)
                Me.m_value2 = 1
                Do While (Me.m_value2 <= 10)
                    If (Me.m_swloval.Item(0)(Me.m_value2) < Me.m_swloval.Item(0)(0)) Then
                        Me.m_index.Value = Me.m_value2
                        Me.m_value2 = 11
                    End If
                    Me.m_value2 += 1
                Loop
                If (Me.m_value2 = 12) Then
                    If ((Not Me.m_uptlref.Value Is Nothing) AndAlso Me.m_uptlref.Value.Exist) Then
                        If Not If(Not Me.m_historytf.Value, True, Me.m_uptlbreak.Value) Then
                            Me.m_uptlref.Value.End = New ChartPoint(MyBase.Bars.Time.Item(0), Me.m_uptlref.Value.PriceValue(MyBase.Bars.Time.Item(0)))
                            Me.m_uptlref.Value.ExtRight = False
                        ElseIf Not Me.m_historytf.Value Then
                            Me.m_uptlref.Value.Delete()
                        End If
                    End If
                    Me.m_uptlref.Value = MyBase.DrwTrendLine.Create(New ChartPoint(Me.m_swlotime.Item(0)(Me.m_index.Value), Me.m_swloval.Item(0)(Me.m_index.Value)), New ChartPoint(Me.m_swlotime.Item(0)(0), Me.m_swloval.Item(0)(0)))
                    If Me.m_uptlbreak.Value Then
                        Me.m_uptlbreak.Value = False
                    End If
                    Me.m_uptlendbar.Value = (Me.m_barnum - Me.swlostrength)
                    Me.m_uptlref.Value.ExtLeft = False
                    Me.m_uptlref.Value.ExtRight = True
                    Me.m_uptlref.Value.Color = Me.m_uptlcolornum
                    If (Me.m_alerttypecaps = "ONCLOSE") Then
                        Me.m_uptlref.Value.Alert = EAlertType.BreakoutOnClose
                    ElseIf (Me.m_alerttypecaps = "INTRABAR") Then
                        Me.m_uptlref.Value.Alert = EAlertType.BreakoutIntrabar
                    Else
                        Me.m_uptlref.Value.Alert = EAlertType.Disabled
                    End If
                End If
            End If
            If ((((Not Me.m_dntlref.Value Is Nothing) AndAlso Me.m_dntlref.Value.Exist) AndAlso (Not Me.m_dntlbreak.Value AndAlso (Me.m_barnum > ((Me.m_dntlendbar.Value + Me.swhistrength) + Me.barspast)))) AndAlso PublicFunctions.DoubleGreater(MyBase.Bars.Close.Item(Me.barspast), Me.m_dntlref.Value.PriceValue(MyBase.Bars.Time.Item(0)))) Then
                Me.m_dntlref.Value.End = New ChartPoint(MyBase.Bars.Time.Item(0), Me.m_dntlref.Value.PriceValue(MyBase.Bars.Time.Item(0)))
                Me.m_dntlref.Value.ExtRight = False
                Me.m_dntlbreak.Value = True
            End If
            If ((((Not Me.m_uptlref.Value Is Nothing) AndAlso Me.m_uptlref.Value.Exist) AndAlso (Not Me.m_uptlbreak.Value AndAlso (Me.m_barnum > ((Me.m_uptlendbar.Value + Me.swlostrength) + Me.barspast)))) AndAlso PublicFunctions.DoubleLess(MyBase.Bars.Close.Item(Me.barspast), Me.m_uptlref.Value.PriceValue(MyBase.Bars.Time.Item(0)))) Then
                Me.m_uptlref.Value.End = New ChartPoint(MyBase.Bars.Time.Item(0), Me.m_uptlref.Value.PriceValue(MyBase.Bars.Time.Item(0)))
                Me.m_uptlref.Value.ExtRight = False
                Me.m_uptlbreak.Value = True
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_barnumber1 = New BarNumber(Me)
            Me.m_swinghighbar1 = New SwingHighBar(Me)
            Me.m_swinglowbar1 = New SwingLowBar(Me)
            Me.m_dntlref = New VariableSeries(Of ITrendLineObject)(Me)
            Me.m_dntlendbar = New VariableObject(Of Integer)(Me)
            Me.m_dntlbreak = New VariableObject(Of Boolean)(Me)
            Me.m_uptlref = New VariableSeries(Of ITrendLineObject)(Me)
            Me.m_uptlendbar = New VariableObject(Of Integer)(Me)
            Me.m_uptlbreak = New VariableObject(Of Boolean)(Me)
            Me.m_index = New VariableObject(Of Integer)(Me)
            Me.m_historytf = New VariableObject(Of Boolean)(Me)
            Me.m_swhitime = New ArraySimple(Of DateTime)(Me, 11)
            Me.m_swhival = New ArraySimple(Of Double)(Me, 11)
            Me.m_swlotime = New ArraySimple(Of DateTime)(Me, 11)
            Me.m_swloval = New ArraySimple(Of Double)(Me, 11)
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_swinghighbar1.instance = New ConstantObject(Of Integer)(1)
            Me.m_swinghighbar1.price = MyBase.Bars.High
            Me.m_swinghighbar1.strength = New Lambda(Of Integer)( Function() Me.swhistrength)
            Me.m_swinghighbar1.length = New Lambda(Of Integer)( Function() (Me.swhistrength + 1))
            Me.m_swinglowbar1.instance = New ConstantObject(Of Integer)(1)
            Me.m_swinglowbar1.price = MyBase.Bars.Low
            Me.m_swinglowbar1.strength = New Lambda(Of Integer)( Function() Me.swlostrength)
            Me.m_swinglowbar1.length = New Lambda(Of Integer)( Function() (Me.swlostrength + 1))
            Me.m_value1 = 0
            Me.m_value2 = 0
            Me.m_dntlendbar.DefaultValue = 0
            Me.m_dntlbreak.DefaultValue = False
            Me.m_dntlcolornum = Me.m_dntlcolor
            Me.m_uptlendbar.DefaultValue = 0
            Me.m_uptlbreak.DefaultValue = False
            Me.m_uptlcolornum = Me.m_uptlcolor
            Me.m_index.DefaultValue = 0
            Me.m_barnum = 0
            Me.m_historytf.DefaultValue = False
            Me.m_alerttypecaps = Nothing
            Me.m_swhival.DefaultValue = -1000000
            Me.m_swloval.DefaultValue = 1000000
        End Sub


        ' Properties
        <Input()> _
        Public Property alerttype As String
            Get
                Return Me.m_alerttype
            End Get
            Set(ByVal value As String)
                Me.m_alerttype = value
            End Set
        End Property

        <Input()> _
        Public Property barspast As Integer
            Get
                Return Me.m_barspast
            End Get
            Set(ByVal value As Integer)
                Me.m_barspast = value
            End Set
        End Property

        <Input()> _
        Public Property dntlcolor As KnownColor
            Get
                Return Me.m_dntlcolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_dntlcolor = Color.FromKnownColor(value)
            End Set
        End Property

        <Input()> _
        Public Property history As String
            Get
                Return Me.m_history
            End Get
            Set(ByVal value As String)
                Me.m_history = value
            End Set
        End Property

        <Input()> _
        Public Property swhistrength As Integer
            Get
                Return Me.m_swhistrength
            End Get
            Set(ByVal value As Integer)
                Me.m_swhistrength = value
            End Set
        End Property

        <Input()> _
        Public Property swlostrength As Integer
            Get
                Return Me.m_swlostrength
            End Get
            Set(ByVal value As Integer)
                Me.m_swlostrength = value
            End Set
        End Property

        <Input()> _
        Public Property uptlcolor As KnownColor
            Get
                Return Me.m_uptlcolor.ToKnownColor
            End Get
            Set(ByVal value As KnownColor)
                Me.m_uptlcolor = Color.FromKnownColor(value)
            End Set
        End Property


        ' Fields
        Private m_alerttype As String
        Private m_alerttypecaps As String
        Private m_barnum As Integer
        Private m_barnumber1 As BarNumber
        Private m_barspast As Integer
        Private m_dntlbreak As VariableObject(Of Boolean)
        Private m_dntlcolor As Color
        Private m_dntlcolornum As Color
        Private m_dntlendbar As VariableObject(Of Integer)
        Private m_dntlref As VariableSeries(Of ITrendLineObject)
        Private m_history As String
        Private m_historytf As VariableObject(Of Boolean)
        Private m_index As VariableObject(Of Integer)
        Private m_swhistrength As Integer
        Private m_swhitime As ArraySimple(Of DateTime)
        Private m_swhival As ArraySimple(Of Double)
        Private m_swinghighbar1 As SwingHighBar
        Private m_swinglowbar1 As SwingLowBar
        Private m_swlostrength As Integer
        Private m_swlotime As ArraySimple(Of DateTime)
        Private m_swloval As ArraySimple(Of Double)
        Private m_uptlbreak As VariableObject(Of Boolean)
        Private m_uptlcolor As Color
        Private m_uptlcolornum As Color
        Private m_uptlendbar As VariableObject(Of Integer)
        Private m_uptlref As VariableSeries(Of ITrendLineObject)
        Private m_value1 As Integer
        Private m_value2 As Integer
    End Class
End Namespace

