﻿Imports PowerLanguage
Imports System

Namespace PowerLanguage.Strategy
    Public Class EntryBar_Pnt_Stop_SX
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_riskpoints = 10
        End Sub

        Protected Overrides Sub CalcBar()
            If (MyBase.StrategyInfo.MarketPosition <= 0) Then
                Me.m_Order.Send((MyBase.Bars.Close.Item(0) - (Me.riskpoints * MyBase.Bars.Point)))
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_Order = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "EbPntLX", EOrderAction.Sell, OrderExit.FromAll))
        End Sub


        ' Properties
        <Input> _
        Public Property riskpoints As Double
            Get
                Return Me.m_riskpoints
            End Get
            Set(ByVal value As Double)
                Me.m_riskpoints = value
            End Set
        End Property


        ' Fields
        Private m_Order As IOrderPriced
        Private m_riskpoints As Double
    End Class
End Namespace

