﻿Imports PowerLanguage
Imports System

Namespace PowerLanguage.Strategy
    Public Class EntryBar__Stop_LX
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_dollarrisk = 1
        End Sub

        Protected Overrides Sub CalcBar()
            If (MyBase.StrategyInfo.MarketPosition >= 0) Then
                Me.m_Order.Send((MyBase.Bars.Close.Item(0) + Me.m_bigpointrisk))
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_Order = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "EbDlrSX", EOrderAction.BuyToCover, OrderExit.FromAll))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_bigpointrisk = (Me.dollarrisk / MyBase.Bars.Info.BigPointValue)
        End Sub


        ' Properties
        <Input> _
        Public Property dollarrisk As Double
            Get
                Return Me.m_dollarrisk
            End Get
            Set(ByVal value As Double)
                Me.m_dollarrisk = value
            End Set
        End Property


        ' Fields
        Private m_bigpointrisk As Double
        Private m_dollarrisk As Double
        Private m_Order As IOrderPriced
    End Class
End Namespace

