﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class MovAvg_Cross_LX
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 9
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_avg.Value = Me.m_averagefc1.Item(0)
            If ((MyBase.Bars.CurrentBar > 1) AndAlso Me.CrossesUnder(MyBase.Bars.Close, Me.m_avg)) Then
                Me.m_Order0.Send
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_averagefc1 = New AverageFC(Me)
            Me.m_avg = New VariableSeries(Of Double)(Me)
            Me.m_Order0 = MyBase.OrderCreator.MarketNextBar(New SOrderParameters(Contracts.Default, "MACrossLX", EOrderAction.Sell, OrderExit.FromAll))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_averagefc1.price = MyBase.Bars.Close
            Me.m_averagefc1.length = New Lambda(Of Integer)( Function() Me.length)
            Me.m_avg.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property


        ' Fields
        Private m_averagefc1 As AverageFC
        Private m_avg As VariableSeries(Of Double)
        Private m_length As Integer
        Private m_Order0 As IOrderMarket
    End Class
End Namespace

