﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class Price_Channel_LE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 20
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_Order0.Send((Me.m_highestfc1.Item(0) + (1 * MyBase.Bars.Point)))
        End Sub

        Protected Overrides Sub Create()
            Me.m_highestfc1 = New HighestFC(Me)
            Me.m_Order0 = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "PChLE", EOrderAction.Buy))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_highestfc1.pricevalue = MyBase.Bars.High
            Me.m_highestfc1.len = New Lambda(Of Integer)( Function() Me.length)
        End Sub


        ' Properties
        <Input> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property


        ' Fields
        Private m_highestfc1 As HighestFC
        Private m_length As Integer
        Private m_Order0 As IOrderPriced
    End Class
End Namespace

