﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class Price_Channel_SE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 20
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_Order1.Send((Me.m_lowestfc1.Item(0) - (1 * MyBase.Bars.Point)))
        End Sub

        Protected Overrides Sub Create()
            Me.m_lowestfc1 = New LowestFC(Me)
            Me.m_Order1 = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "PChSE", EOrderAction.SellShort))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_lowestfc1.pricevalue = MyBase.Bars.Low
            Me.m_lowestfc1.len = New Lambda(Of Integer)( Function() Me.length)
        End Sub


        ' Properties
        <Input> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property


        ' Fields
        Private m_length As Integer
        Private m_lowestfc1 As LowestFC
        Private m_Order1 As IOrderPriced
    End Class
End Namespace

