﻿Imports PowerLanguage
Imports System

Namespace PowerLanguage.Strategy
    Public Class Profitable_Closes_LX
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_numprofitcloses = 5
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_mp.Value = 0
            If (MyBase.StrategyInfo.MarketPosition > 0) Then
                Me.m_mp.Value = 1
            End If
            If (MyBase.StrategyInfo.MarketPosition < 0) Then
                Me.m_mp.Value = -1
            End If
            If (Not Me.m_mp.Value = 0) Then
                If (Not Me.m_mp.Item(1) = Me.m_mp.Value) Then
                    Me.m_counter.Value = 0
                    Me.m_ep.Value = Me.EntryPrice()
                End If
                If (PublicFunctions.DoubleGreater(MyBase.Bars.Close.Item(0), Me.m_ep.Value) AndAlso PublicFunctions.DoubleGreater(Me.m_mp.Value, 0)) Then
                    Me.m_counter.Value = (Me.m_counter.Value + 1)
                End If
                If (Me.m_counter.Value = Me.numprofitcloses) Then
                    Me.m_Order.Send()
                End If
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_mp = New VariableSeries(Of Double)(Me)
            Me.m_ep = New VariableObject(Of Double)(Me)
            Me.m_counter = New VariableObject(Of Integer)(Me)
            Me.m_Order = MyBase.OrderCreator.MarketNextBar(New SOrderParameters(Contracts.Default, "PftClsLX", EOrderAction.Sell, OrderExit.FromAll))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_mp.DefaultValue = 0
            Me.m_ep.DefaultValue = 0
            Me.m_counter.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property numprofitcloses As Integer
            Get
                Return Me.m_numprofitcloses
            End Get
            Set(ByVal value As Integer)
                Me.m_numprofitcloses = value
            End Set
        End Property


        ' Fields
        Private m_counter As VariableObject(Of Integer)
        Private m_ep As VariableObject(Of Double)
        Private m_mp As VariableSeries(Of Double)
        Private m_numprofitcloses As Integer
        Private m_Order As IOrderMarket
    End Class
End Namespace

