﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class Comm_Sel_Index
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_mymargin = 1000
            Me.m_mycommission = 25
            Me.m_length = 14
        End Sub

        Protected Overrides Sub CalcBar()
            Me.Plot1.Set(0, Me.m_csi1.Item(0))
        End Sub

        Protected Overrides Sub Create()
            Me.m_csi1 = New CSI(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("CSI", EPlotShapes.Line, Color.Blue, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_csi1.mymargin = New Lambda(Of Double)( Function() Me.mymargin)
            Me.m_csi1.mycommission = New Lambda(Of Double)( Function() Me.mycommission)
            Me.m_csi1.length = New Lambda(Of Integer)( Function() Me.length)
        End Sub


        ' Properties
        <Input> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        <Input> _
        Public Property mycommission As Double
            Get
                Return Me.m_mycommission
            End Get
            Set(ByVal value As Double)
                Me.m_mycommission = value
            End Set
        End Property

        <Input> _
        Public Property mymargin As Double
            Get
                Return Me.m_mymargin
            End Get
            Set(ByVal value As Double)
                Me.m_mymargin = value
            End Set
        End Property


        ' Fields
        Private m_csi1 As CSI
        Private m_length As Integer
        Private m_mycommission As Double
        Private m_mymargin As Double
        Private Plot1 As IPlotObject
    End Class
End Namespace

