﻿Imports PowerLanguage
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class Spread__Ratio
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
        End Sub

        Protected Overrides Sub CalcBar()
            If (Not Me.dataseries2.Item(0) = 0) Then
                Me.Plot1.Set(0, (Me.dataseries1.Item(0) / Me.dataseries2.Item(0)))
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("SprdRatio", EPlotShapes.Line, Color.Cyan, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_dataseries1 = MyBase.Bars.Close
            Me.m_dataseries2 = MyBase.BarsOfData(2).Close
        End Sub


        ' Properties
        Private ReadOnly Property dataseries1 As ISeries(Of Double)
            Get
                Return Me.m_dataseries1
            End Get
        End Property

        Private ReadOnly Property dataseries2 As ISeries(Of Double)
            Get
                Return Me.m_dataseries2
            End Get
        End Property


        ' Fields
        Private m_dataseries1 As ISeries(Of Double)
        Private m_dataseries2 As ISeries(Of Double)
        Private Plot1 As IPlotObject
    End Class
End Namespace

