﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class Ultimate_Osc
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_fastlength = 7
            Me.m_medlength = 14
            Me.m_slowlength = &H1C
        End Sub

        Protected Overrides Sub CalcBar()
            Me.Plot1.Set(0, Me.m_ultimateoscillator1.Item(0))
        End Sub

        Protected Overrides Sub Create()
            Me.m_ultimateoscillator1 = New UltimateOscillator(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("UltOsc", EPlotShapes.Line, Color.Yellow, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_ultimateoscillator1.shortlength = New Lambda(Of Integer)( Function() Me.fastlength)
            Me.m_ultimateoscillator1.middllength = New Lambda(Of Integer)( Function() Me.medlength)
            Me.m_ultimateoscillator1.longlength = New Lambda(Of Integer)( Function() Me.slowlength)
        End Sub


        ' Properties
        <Input> _
        Public Property fastlength As Integer
            Get
                Return Me.m_fastlength
            End Get
            Set(ByVal value As Integer)
                Me.m_fastlength = value
            End Set
        End Property

        <Input> _
        Public Property medlength As Integer
            Get
                Return Me.m_medlength
            End Get
            Set(ByVal value As Integer)
                Me.m_medlength = value
            End Set
        End Property

        <Input> _
        Public Property slowlength As Integer
            Get
                Return Me.m_slowlength
            End Get
            Set(ByVal value As Integer)
                Me.m_slowlength = value
            End Set
        End Property


        ' Fields
        Private m_fastlength As Integer
        Private m_medlength As Integer
        Private m_slowlength As Integer
        Private m_ultimateoscillator1 As UltimateOscillator
        Private Plot1 As IPlotObject
    End Class
End Namespace

