﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class Volatility
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 14
        End Sub

        Protected Overrides Sub CalcBar()
            Me.Plot1.Set(0, Me.m_volatility1.Item(0))
        End Sub

        Protected Overrides Sub Create()
            Me.m_volatility1 = New PowerLanguage.Function.Volatility(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("Volty", EPlotShapes.Line, Color.Blue, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_volatility1.length = New Lambda(Of Integer)( Function() Me.length)
        End Sub


        ' Properties
        <Input> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property


        ' Fields
        Private m_length As Integer
        Private m_volatility1 As PowerLanguage.Function.Volatility
        Private Plot1 As IPlotObject
    End Class
End Namespace

