﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System
Imports System.Drawing

Namespace PowerLanguage.Indicator
    Public Class Volatility_Std_Dev
        Inherits IndicatorObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 30
        End Sub

        Protected Overrides Sub CalcBar()
            Me.Plot1.Set(0, Me.m_volatilitystddev1.Item(0))
        End Sub

        Protected Overrides Sub Create()
            Me.m_volatilitystddev1 = New VolatilityStdDev(Me)
            Me.Plot1 = MyBase.AddPlot(New PlotAttributes("VoltySDev", EPlotShapes.Line, Color.Cyan, Color.Empty, 0, 0, True))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_volatilitystddev1.numdays = New Lambda(Of Integer)( Function() Me.length)
        End Sub


        ' Properties
        <Input> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property


        ' Fields
        Private m_length As Integer
        Private m_volatilitystddev1 As VolatilityStdDev
        Private Plot1 As IPlotObject
    End Class
End Namespace

