﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class EntryBar_ATR_Stop_SX
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_atrlength = 5
            Me.m_numatrs = 1
        End Sub

        Protected Overrides Sub CalcBar()
            If (MyBase.StrategyInfo.MarketPosition <= 0) Then
                Me.m_Order.Send((MyBase.Bars.Close.Item(0) - (Me.m_avgtruerange.Item(0) * Me.numatrs)))
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_avgtruerange = New AvgTrueRange(Me)
            Me.m_Order = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "EbAtrLX", EOrderAction.Sell, OrderExit.FromAll))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_avgtruerange.length = New Lambda(Of Integer)( Function() Me.atrlength)
        End Sub


        ' Properties
        <Input> _
        Public Property atrlength As Integer
            Get
                Return Me.m_atrlength
            End Get
            Set(ByVal value As Integer)
                Me.m_atrlength = value
            End Set
        End Property

        <Input> _
        Public Property numatrs As Integer
            Get
                Return Me.m_numatrs
            End Get
            Set(ByVal value As Integer)
                Me.m_numatrs = value
            End Set
        End Property


        ' Fields
        Private m_atrlength As Integer
        Private m_avgtruerange As AvgTrueRange
        Private m_numatrs As Integer
        Private m_Order As IOrderPriced
    End Class
End Namespace

