﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class Pivot_Reversal_LE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_strength = 4
        End Sub

        Protected Overrides Sub CalcBar()
            If (Not Me.m_swinghigh1.Item(0) = -1) Then
                Me.m_setup.Value = True
                Me.m_pivothigh.Value = MyBase.Bars.High.Item(Me.strength)
            Else
                Me.m_condition1 = (Me.m_setup.Value AndAlso PublicFunctions.DoubleGreaterEquals(MyBase.Bars.High.Item(0), (Me.m_pivothigh.Value + (1 * MyBase.Bars.Point))))
                If Me.m_condition1 Then
                    Me.m_setup.Value = False
                End If
            End If
            If Me.m_setup.Value Then
                Me.m_Order0.Send((Me.m_pivothigh.Value + (1 * MyBase.Bars.Point)))
            End If
        End Sub

        Protected Overrides Sub Create()
            Me.m_swinghigh1 = New SwingHigh(Me)
            Me.m_setup = New VariableObject(Of Boolean)(Me)
            Me.m_pivothigh = New VariableObject(Of Double)(Me)
            Me.m_Order0 = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "PivRevLE", EOrderAction.Buy))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_swinghigh1.instance = New ConstantObject(Of Integer)(1)
            Me.m_swinghigh1.price = MyBase.Bars.High
            Me.m_swinghigh1.strength = New Lambda(Of Integer)( Function() Me.strength)
            Me.m_swinghigh1.length = New Lambda(Of Integer)( Function() (Me.strength + 1))
            Me.m_condition1 = False
            Me.m_setup.DefaultValue = False
            Me.m_pivothigh.DefaultValue = 0
        End Sub


        ' Properties
        <Input()> _
        Public Property strength As Integer
            Get
                Return Me.m_strength
            End Get
            Set(ByVal value As Integer)
                Me.m_strength = value
            End Set
        End Property


        ' Fields
        Private m_condition1 As Boolean
        Private m_Order0 As IOrderPriced
        Private m_pivothigh As VariableObject(Of Double)
        Private m_setup As VariableObject(Of Boolean)
        Private m_strength As Integer
        Private m_swinghigh1 As SwingHigh
    End Class
End Namespace

