﻿Imports PowerLanguage
Imports PowerLanguage.Function
Imports System

Namespace PowerLanguage.Strategy
    Public Class Volty_Expan_Close_LE
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_length = 5
            Me.m_numatrs = 0.75
        End Sub

        Protected Overrides Sub CalcBar()
            Me.m_Order0.Send((MyBase.Bars.Close.Item(0) + (Me.m_avgtruerange.Item(0) * Me.numatrs)))
        End Sub

        Protected Overrides Sub Create()
            Me.m_avgtruerange = New AvgTrueRange(Me)
            Me.m_Order0 = MyBase.OrderCreator.Stop(New SOrderParameters(Contracts.Default, "VltClsLE", EOrderAction.Buy))
        End Sub

        Protected Overrides Sub StartCalc()
            Me.m_avgtruerange.length = New Lambda(Of Integer)( Function() Me.length)
        End Sub


        ' Properties
        <Input> _
        Public Property length As Integer
            Get
                Return Me.m_length
            End Get
            Set(ByVal value As Integer)
                Me.m_length = value
            End Set
        End Property

        <Input> _
        Public Property numatrs As Double
            Get
                Return Me.m_numatrs
            End Get
            Set(ByVal value As Double)
                Me.m_numatrs = value
            End Set
        End Property


        ' Fields
        Private m_avgtruerange As AvgTrueRange
        Private m_length As Integer
        Private m_numatrs As Double
        Private m_Order0 As IOrderPriced
    End Class
End Namespace

