﻿Imports PowerLanguage
Imports System

Namespace PowerLanguage.Strategy
    Public Class _Percent_Exit_Pair
        Inherits SignalObject
        ' Methods
        Public Sub New(ByVal ctx As Object)
            MyBase.New(ctx)
            Me.m_profittargetpct = 0.1
            Me.m_stoplosspct = 0.05
        End Sub

        Protected Overrides Sub CalcBar()
            MyBase.CurSpecOrdersMode = ESpecOrdersMode.PerContract
            If (MyBase.StrategyInfo.MarketPosition <> 0) Then
                If PublicFunctions.DoubleGreater(Me.profittargetpct, 0) Then
                    MyBase.GenerateProfitTarget((Me.EntryPrice() * Me.profittargetpct))
                End If
                If PublicFunctions.DoubleGreater(Me.stoplosspct, 0) Then
                    MyBase.GenerateStopLoss((Me.EntryPrice() * Me.stoplosspct))
                End If
            Else
                If PublicFunctions.DoubleGreater(Me.profittargetpct, 0) Then
                    MyBase.GenerateProfitTarget((MyBase.Bars.Close.Item(0) * Me.profittargetpct))
                End If
                If PublicFunctions.DoubleGreater(Me.stoplosspct, 0) Then
                    MyBase.GenerateStopLoss((MyBase.Bars.Close.Item(0) * Me.stoplosspct))
                End If
            End If
        End Sub


        ' Properties
        <Input> _
        Public Property profittargetpct As Double
            Get
                Return Me.m_profittargetpct
            End Get
            Set(ByVal value As Double)
                Me.m_profittargetpct = value
            End Set
        End Property

        <Input> _
        Public Property stoplosspct As Double
            Get
                Return Me.m_stoplosspct
            End Get
            Set(ByVal value As Double)
                Me.m_stoplosspct = value
            End Set
        End Property


        ' Fields
        Private m_profittargetpct As Double
        Private m_stoplosspct As Double
    End Class
End Namespace

